% minmnb_aufg.m
% Lsung zu Aufgabe 7.8.4, optimization TB
% Minimierung unter Nebenbedingungen
format compact; clear all

% In der Funktion f_minmnb.m ist die Funktion
% f(x)=10*exp(-x(1)^2-x(2)^2)*(x(1)^3+x(2)^2+0.5) definiert
% Funktion f_minmnb.m graphisch darstellen
[X,Y] = meshgrid(-3:0.1:3,-3:0.1:3);
Z = 10.*exp(-X.^2-Y.^2).*(X.^3+Y.^2+0.5);
mesh(X,Y,Z)
xlabel('x_1'); ylabel('x_2')
axis([-3 3 -3 3 -4 4])
grid on

% Nebenbedingung in selben Plot einzeichnen
hold on
t = 0:0.1:2*pi;
x = 1.25*sin(t); y = 2*cos(t)-1;
for i=1:1:length(t)
   z(i) = f_minmnb([x(i) y(i)]);
end   
plot3(x,y,z)

% Das Minimum liegt in der Nhe von x_1=-1, x_2=0
% Optionen setzen
options = optimset(@fmincon); 
options=optimset(options,'Display','iter','Algorithm','active-set');
% In der Funktion neb_minmnb.m ist die Gleichungs-Nebenbedingung definiert

% Minimum bestimmen
x0 = [-1 0];         % Startwert vorgeben
[xmin,ymin] = fmincon(@f_minmnb,x0,[],[],[],[],[],[],@neb_minmnb,options)
