% min_onb.m
% Kap. 7.4
% Minimierung ohne Nebenbedingungen

format compact

% funktion5.m graphisch darstellen
ezplot('funktion5', [-2 3])
title('funktion5.m')
ylabel('f(x)')
axis([-2 3 -3 3]); set(gca,'xtick',[-2 -1 0 1 2 3])
grid on
% exportfig(gcf,'funktion5.eps','width', 18, 'height', 9)


pause


% Minimumsuche der skalaren Funktion funktion5.m
% in einem vorgegeben Intervall mittels fminbnd

options = optimset(@fminbnd); 
options = optimset(options,'Display','final');
x1 = 1; x2 = 2;
[x, fval, exitflag] = fminbnd(@funktion5, x1, x2, options)

pause

% Maximum bestimmen: funktion6.m = -1 * funktion5.m

options = optimset(@fminbnd); 
options = optimset(options,'Display','final');
x1 = -1; x2 = 0;
[x, fval, exitflag] = fminbnd(@funktion6, x1, x2, options)


pause


% Minimierung ohne NB der Funktion funktion7.m
% (2 Vernderliche)

% funktion7 plotten
clear Z
xp = -1.5:0.1:1.5; yp = -1.5:0.1:1.5;
[X, Y] = meshgrid(xp, yp);
Z = 2.*X.^4 + Y.^4 -2.*X.^2 -2.*Y.^2 + 4.*sin(X.*Y);
%subplot(2,2,1)
figure
surf(X,Y,Z)
view(-13,22)
axis([-1.5 1.5 -1.5 1.5 -5 10])
xlabel('x_1'); ylabel('x_2'); zlabel('f(x_1,x_2)'); title('Zielfunktion')

% print -depsc f7.eps


pause


% erstes Minimum von funktion7.m

options = optimset(@fminunc);
options = optimset(options,'Display','final','LargeScale','off');
x0 = [1 -1];
[x, fval] = fminunc(@funktion7, x0, options)


pause


% zweites Minimum

options = optimset(@fminunc);
options = optimset(options,'Display','final','LargeScale','off');
x0 = [-1 1];
[x, fval] = fminunc(@funktion7, x0, options)

pause

% Output Funktion ansteuern
options = optimset(@fminunc);
options = optimset(options,'OutputFcn',@outfcn,'Display','final','LargeScale','off');
x0 = [-1 1];
[x, fval] = fminunc(@funktion7, x0, options)
verlauf